gpointer Call_Activate_Mask(GtkComboBox *Combo, gpointer What)
{
	Set_Active_Mask(gtk_combo_box_get_active(Combo));
	return NULL;
}

void Call_Open(GtkMenuItem *Menu_Item, gpointer What)
{
	GtkTreeIter Parent_Item, Child_Item;
	gchar *Encoded_Share_Path;
	gchar *Utf8_Share_Path;
	gint Share_Type; 
	gulong Share_Size;
	GThread *Open_Thread;

	gtk_tree_model_get_iter(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget)), &Parent_Item, ((struct Widget_Path *)What)->Path);

	while (gtk_tree_model_iter_children(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget)), &Child_Item, &Parent_Item)){
		gtk_tree_store_remove(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget))), &Child_Item);
	}
	gtk_tree_model_get(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget)), &Parent_Item, 2, &Share_Size, 3, &Utf8_Share_Path, 4, &Share_Type,-1);
	
	Encoded_Share_Path = g_convert(Utf8_Share_Path, -1, Samba_Filename_Encoding, "UTF-8", NULL, NULL, NULL);
	
	Browse.Pth = Encoded_Share_Path;
	Browse.Iter = Parent_Item;
	Browse.Type = Share_Type;
	
	if (Menu_Item != NULL) gtk_widget_destroy(gtk_widget_get_parent(GTK_WIDGET(Menu_Item)));
	
	Open_Thread = g_thread_create(Share_Open, &Browse, TRUE, NULL);
}

void Call_Append_Download(GtkMenuItem *Menu_Item, gpointer What)
{
	GtkTreeIter Parent_Item, Download_Iter;
	gchar *Utf8_Share_Path;
	gint Share_Type; 
	gulong Share_Size;

	gtk_tree_model_get_iter(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget)), &Parent_Item, ((struct Widget_Path *)What)->Path);
	gtk_tree_model_get(gtk_tree_view_get_model(GTK_TREE_VIEW(((struct Widget_Path *)What)->Widget)), &Parent_Item, 2, &Share_Size, 3, &Utf8_Share_Path, 4, &Share_Type,-1);
	
	if (Menu_Item != NULL) gtk_widget_destroy(gtk_widget_get_parent(GTK_WIDGET(Menu_Item)));
	
	gtk_tree_store_append(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Download_Iter, NULL);
	gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Download_Iter, 0, Download_Icon[0], 1, "Waiting", 3, Utf8_Share_Path, 4, Share_Size, 5, Share_Type, -1);
}

void Call_Dialog_Destroy(GtkButton *Button, gpointer What)
{
	gtk_widget_destroy(What);
}

gpointer Call_Mouse_Event(GtkWidget *Widget, GdkEventButton *Event, gpointer Data)
{
	GtkTreePath *Tree_Path;
	GtkTreeSelection *Select;
	GtkTreeIter Iter;
	guint Type;

	
	gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW(Widget), Event->x, Event-> y, &Tree_Path, NULL, NULL, NULL);	
		
	if (Tree_Path != NULL) {
		
		Recd.Widget = Widget;
		Recd.Path = Tree_Path;
		
		gtk_tree_model_get_iter(gtk_tree_view_get_model(GTK_TREE_VIEW(Widget)), &Iter, Tree_Path);		
		gtk_tree_model_get(gtk_tree_view_get_model(GTK_TREE_VIEW(Widget)), &Iter, 4, &Type,-1);
		
		if ((Event->type == GDK_BUTTON_PRESS) && (Event->button == 1)){
			Select = gtk_tree_view_get_selection(GTK_TREE_VIEW(Widget));
			gtk_tree_selection_select_path(Select, Tree_Path);
		}
		if ((Event->type == GDK_2BUTTON_PRESS) && (Event->button == 1)){
			if (Type == 8) Call_Append_Download(NULL, &Recd);
			else 	Call_Open(NULL, &Recd);
		}
		if ((Event->type == GDK_BUTTON_PRESS) && (Event->button == 3)){
			if (strcmp(Data, "Browser") == 0){
				if (Browser_Popup_Menu != NULL) gtk_widget_destroy(Browser_Popup_Menu);
				Create_Browser_Popup(&Recd);	
				gtk_menu_popup(GTK_MENU(Browser_Popup_Menu), NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time());
			}
			if (strcmp(Data, "Seacher") == 0){
				if (Searcher_Popup_Menu != NULL) gtk_widget_destroy(Searcher_Popup_Menu);
				Create_Searcher_Popup(&Recd);
				gtk_menu_popup(GTK_MENU(Searcher_Popup_Menu), NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time());		
			}
			if (strcmp(Data, "Downloader") == 0){
//				if (Downloader_Popup_Menu != NULL) gtk_widget_destroy(Downloader_Popup_Menu);
//				Create_Downloader_Popup();
//				gtk_menu_popup(GTK_MENU(Downloader_Popup_Menu), NULL, NULL, NULL, NULL, 3, gtk_get_current_event_time());		
			}
		}
	}
	return NULL;
}

void Clear_List(GtkButton *button, gpointer What)
{
	gtk_list_store_clear(GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Search_List))));
}

void Clear_Tree(GtkButton *button, gpointer What)
{
	Stop_Download(NULL);
	gtk_tree_store_clear(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))));
}

void Start_Search(GtkButton *button, gpointer Search_Model)
{
	GThread *Search_Thread;
	
	if (gtk_combo_box_get_active_text(GTK_COMBO_BOX(Selecter)) == NULL){
//		Show_Diallog(GTK_MESSAGE_WARNING, "File type for searching not selected!\nIf necessary fill data on Properties page for new records");
	}
	else{
		Search_Flag = TRUE;
		Search_Thread = g_thread_create(Search_Files, Search_Model, TRUE, NULL);
	}
}

void Stop_Search(GtkButton *button)
{
	Search_Flag = FALSE;
}

void Start_Download(GtkButton *button, gpointer Download_Model)
{
//	GThread *Scan_Load_Thread;	
	GThread *Download_Thread;

	Download_Flag = TRUE;

//	Scan_Load_Thread = g_thread_create(Scan_Downloads, Share_Path, TRUE, NULL);;
	Download_Thread = g_thread_create(Download_Files, Download_Model, TRUE, NULL);
}

void Stop_Download(GtkButton *button)
{
	Download_Flag = FALSE;
}

void Call_Main_Quit(GtkWidget* Widget)
{	
	gtk_widget_destroy(Main_Window);
	gtk_main_quit();
}
